<template>
    <div class="list-view">
        <div class="filters-container">
            <el-form :model="form" inline size="mini" label-width="100px">
                <el-row>
                    <el-col :span="8">
                        <el-form-item label="展演活动名称">
                            <el-select
                                v-model="performanceId"
                                clearable
                                filterable
                                placeholder="展演活动名称"
                                style="width: 100%"
                            >
                                <el-option
                                    v-for="item in performances"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item label="考级机构名称">
                            <el-select
                                v-model="form.gradingOrganizationId"
                                clearable
                                filterable
                                placeholder="考级机构"
                                style="width: 100%"
                            >
                                <el-option
                                    v-for="item in gradingOrganizationIdOptions"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item label="承办单位名称">
                            <el-select
                                v-model="form.organizationId"
                                clearable
                                filterable
                                placeholder="承办单位"
                                style="width: 100%"
                            >
                                <el-option
                                    v-for="item in organizationIdOptions"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row>
                    <el-col :span="8"
                        ><el-form-item label="考级点名称">
                            <el-input placeholder="考级点名称" v-model="search" clearable></el-input> </el-form-item
                    ></el-col>

                    <el-col :span="8">
                        <el-form-item label="参赛专业">
                            <el-cascader
                                ref="artCascader"
                                style="width: 100%"
                                v-model="form.specialtyId"
                                :props="optionProps"
                                :options="artTypes"
                                :show-all-levels="false"
                                placeholder="请选择专业"
                                clearable
                            >
                            </el-cascader>
                        </el-form-item>
                    </el-col>
                    <el-col :span="8"
                        ><el-form-item label="参赛组别">
                            <el-select v-model="form.competitionGroup" clearable filterable placeholder="参赛组别">
                                <el-option
                                    v-for="item in competitionGroupOptions"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                </el-option>
                            </el-select> </el-form-item
                    ></el-col>
                    <el-col :span="8"
                        ><el-form-item label="参赛级别" v-if="form.competitionGroup">
                            <el-select
                                v-model="form.levelSettingId"
                                clearable
                                filterable
                                placeholder="参赛级别"
                                style="width: 100%"
                                v-if="form.competitionGroup == 'SINGLE'"
                            >
                                <el-option
                                    v-for="item in levelSingleOptions"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                    <span style="float: left">{{ item.label }}</span>
                                    <span style="float: right; color: #8492a6; font-size: 13px">{{ item.desc }}</span>
                                </el-option>
                            </el-select>
                            <el-select
                                v-model="form.levelSettingId"
                                clearable
                                filterable
                                placeholder="请选择"
                                style="width: 100%"
                                v-else
                            >
                                <el-option
                                    v-for="item in levelCollectiveOptions"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                                >
                                    <span style="float: left">{{ item.label }}</span>
                                    <span style="float: right; color: #8492a6; font-size: 13px">{{ item.desc }}</span>
                                </el-option>
                            </el-select>
                        </el-form-item></el-col
                    >
                </el-row>
                <el-form-item>
                    <el-button @click="getData" type="primary" icon="el-icon-search">搜索 </el-button>
                    <el-button @click="clearSearch" type="primary">清空 </el-button>
                    <!-- <el-button @click="addRow" type="primary" icon="el-icon-plus">添加 </el-button> -->
                    <el-button
                        @click="download"
                        type="primary"
                        icon="el-icon-download"
                        :loading="downloading"
                        :disabled="totalElements < 1"
                        >导出
                    </el-button>
                </el-form-item>
            </el-form>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <el-table-column prop="name" label="节目名称"> </el-table-column>
            <el-table-column prop="specialty" label="参赛专业"> </el-table-column>
            <el-table-column
                prop="competitionGroup"
                label="参赛组别"
                :formatter="competitionGroupFormatter"
                min-width="70"
            >
            </el-table-column>
            <el-table-column prop="level" label="参赛级别" min-width="70"> </el-table-column>
            <el-table-column prop="durationOfWork" label="作品时长" min-width="70"> </el-table-column>
            <el-table-column prop="quantity" label="参赛人数" min-width="70"> </el-table-column>
            <el-table-column prop="contact" label="联系人" min-width="68"> </el-table-column>
            <el-table-column prop="phone" label="联系电话" min-width="95"> </el-table-column>
            <el-table-column prop="gradingOrganization" label="考级机构" show-overflow-tooltip min-width="160">
            </el-table-column>
            <el-table-column prop="organization" label="承办单位" min-width="160"> </el-table-column>
            <el-table-column prop="examPoint" label="考级点" min-width="160"> </el-table-column>
            <el-table-column label="操作" align="left" fixed="right" min-width="280">
                <template slot-scope="{ row }">
                    <el-button @click="showRow(row)" size="mini" plain>查看</el-button>
                    <el-button type="warning" @click="playVideo(row)" size="mini" plain v-if="row.video"
                        >浏览视频</el-button
                    >
                    <el-button @click="showCode(row)" type="primary" size="mini" plain>查看二维码</el-button>
                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>

        <el-dialog title="二维码" :visible.sync="dialogCode" width="400px" center>
            <div style="margin-left: 70px;">
                <qrcode-vue :value="dialogUrl" :size="200" level="H" />
            </div>
        </el-dialog>

        <el-dialog
            class="videoDialog"
            destroy-on-close
            center
            append-to-body
            :visible.sync="showViedo"
            @close="closeEvent"
            width="70%"
        >
            <video
                :src="videoUrl.src"
                controlsList="nodownload noremote footbar"
                controls
                style="height: 100%; max-width: 100%"
                oncontextmenu="return false;"
                onmouseleave="leaveVideo(this)"
                ref="video"
                v-if="showViedo"
            >
                您的浏览器不支持 video 标签。
            </video>
        </el-dialog>
    </div>
</template>
<script>
import delChild from '@/mixins/delChild';
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import QrcodeVue from 'qrcode.vue';

export default {
    name: 'ProgrammeList',
    mixins: [pageableTable, delChild],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/programme/backAll',
            downloading: false,
            competitionGroupOptions: [
                { label: '个人', value: 'SINGLE' },
                { label: '集体', value: 'COLLECTIVE' }
            ],
            form: {},
            levelSingleOptions: [],
            levelCollectiveOptions: [],
            dialogUrl: '',
            dialogCode: false,
            gradingOrganizationIdOptions: [],
            organizationIdOptions: [],
            performanceId: '',
            performances: [],
            artTypes: [],
            optionProps: {
                value: 'id',
                label: 'name',
                children: 'children',
                multiple: false,
                emitPath: false,
                checkStrictly: true,
                expandTrigger: 'hover'
            },
            showViedo: false,
            videoUrl: ''
        };
    },
    created() {
        this.$http
            .post('/setting/byFlag', { flag: 3 })
            .then(res => {
                if (res.length > 0) {
                    res.forEach(item => {
                        this.levelSingleOptions.push({
                            label: item.name,
                            value: item.id,
                            desc: item.code
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        if (this.$route.query.pid) {
            this.performanceId = Number(this.$route.query.pid);
        }
        this.$http
            .post('/setting/byFlag', { flag: 4 })
            .then(res => {
                if (res.length > 0) {
                    res.forEach(item => {
                        this.levelCollectiveOptions.push({
                            label: item.name,
                            value: item.id,
                            desc: item.code
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/gradingOrganization/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.gradingOrganizationIdOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/organization/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.organizationIdOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post(
                '/performance/all',
                {
                    size: 1000,
                    sort: 'year,desc',
                    query: {
                        publish: true
                    }
                },
                { body: 'json' }
            )
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.performances.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                    this.performanceId = res.content[0].id;
                    this.getData();
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/artType/allList')
            .then(res => {
                this.artTypes = this.delChild(res);
            })
            .catch(e => {
                console.log(e);
            });
    },
    components: {
        QrcodeVue
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        competitionGroupFormatter(row, column, cellValue, index) {
            let selectedOption = this.competitionGroupOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            let data = {
                sort: 'createdAt,desc',
                query: {}
            };
            if (this.form.competitionGroup) {
                data.query.competitionGroup = this.form.competitionGroup;
            }
            if (this.form.levelSettingId) {
                data.query.levelSettingId = this.form.levelSettingId;
            }
            if (this.form.gradingOrganizationId) {
                data.query.gradingOrganizationId = this.form.gradingOrganizationId;
            }
            if (this.form.organizationId) {
                data.query.organizationId = this.form.organizationId;
            }
            if (this.form.specialtyId) {
                data.query.code = this.getCode(this.form.specialtyId);
            }
            if (this.performanceId) {
                data.query.performanceId = this.performanceId;
            }
            return data;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/programmeEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        showRow(row) {
            this.$router.push({
                path: '/programmeShow',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;

            let data = {
                sort: 'createdAt,desc',
                query: {}
            };
            if (this.form.competitionGroup) {
                data.query.competitionGroup = this.form.competitionGroup;
            }
            if (this.form.levelSettingId) {
                data.query.levelSettingId = this.form.levelSettingId;
            }
            if (this.form.gradingOrganizationId) {
                data.query.gradingOrganizationId = this.form.gradingOrganizationId;
            }
            if (this.organizationId) {
                data.query.form.organizationId = this.form.organizationId;
            }
            if (this.form.specialtyId) {
                data.query.code = this.getCode(this.form.specialtyId);
            }
            if (this.performanceId) {
                data.query.performanceId = this.performanceId;
            }

            this.$axios
                .get('/programme/excel', {
                    responseType: 'blob',
                    params: data
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/programme/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        showCode(row) {
            this.dialogCode = true;
            this.dialogUrl =
                'http://wljtest.izouma.com/h5/home?performanceId=' +
                row.performanceId +
                '&performanceApplyId=' +
                row.id;
        },
        clearSearch() {
            // this.competitionGroup = '';
            // this.levelSettingId = '';
            // this.gradingOrganizationId = '';
            // this.organizationId = '';
            // this.specialtyId = '';
            this.form = {};
            this.getData();
        },
        getCode(value) {
            return this.forTree(this.artTypes, value).code;
        },
        forTree(list, value) {
            var result = null;
            if (!list) {
                return;
            }
            for (var i in list) {
                if (result !== null) {
                    break;
                }
                var item = list[i];
                if (item.id == value) {
                    result = item;
                    break;
                } else if (item.children && item.children.length > 0) {
                    result = this.forTree(item.children, value);
                }
            }
            return result;
        },
        closeEvent() {
            document.exitPictureInPicture();
        },
        playVideo(row) {
            this.showViedo = true;
            this.videoUrl = row.video;
            console.log(row.video);
        }
    }
};
</script>
<style lang="less" scoped>
.right {
    float: right;
}
/deep/.el-form-item--mini.el-form-item,
.el-form-item--small.el-form-item {
    margin-bottom: 10px;
}
.videoDialog {
    display: flex;
    align-items: center;
    justify-content: center;
    .el-dialog {
        max-width: 900px;
        margin-top: 0px;

        .close {
            position: absolute;
            right: 0px;
            top: -42px;
            width: 71px;
            height: 32px;
            background: #00000015;

            font-size: 12px;
            color: #fdffff;
            line-height: 32px;
            text-align: center;
            cursor: pointer;

            &:hover {
                background: #00000055;
            }
        }
    }
    .el-dialog__header {
        display: none;
    }

    .el-dialog__body {
        padding: 0;

        video {
            display: block;
            height: auto;
            width: 100%;
            outline: none;
        }
    }
}
</style>
